﻿//search autocomplete

//provider options (case sensitive)
//solr, searchserver, google, bing
var provider = 'solr';
//max number of results to retrieve
var maxResults = 10;
//character length 
var minLen = 2
//show highlighted items
var showHighlights = true;
//show hints as you type
var showHints = true;
//handler location
var handlerLoc = 'AutoComplete.ashx';
//handler complete url
var handlerURL = '';
var querysuggestions = null;
var searchTemplate = '/searchtemplate.aspx?q=';

function parseQueryVal(val) {
    if (provider === 'solr') {
        return val.Completion;
    }
    else {
        return val.Suggestion;
    }
}

$(document).ready(function () {
    $('.searchTB').val('');
    var currentSearchText = "";
    if ($('.search-query').length > 0) {
        currentSearchText = $('.search-query').val();
    }
    initSearchTypeahead();
    $('.search-query').val(currentSearchText);
    $('#query .twitter-typeahead').attr('style', '');
    //New case autotype for customer or email
    if ($('.typeaheadCustomer').length > 0) {
        initCustomerTypeahead();
    }
});

function initTypeahead() {
    $('.typeaheadCustomer').typeahead({
        highlight: showHighlights,
        hint: showHints,
        minLength: minLen,
    },
    {
        limit: 10,
        source: customersuggestions.ttAdapter(),
    }).on('typeahead:autocompleted', onSelected);

    customersuggestions.initialize();
}

function initSearchTypeahead() {
    handlerURL = handlerLoc + '?provider=' + provider + '&maxResults=' + maxResults + '&query=%QUERY';

    querysuggestions = new Bloodhound({
        datumTokenizer: function (d) {
            return Bloodhound.tokenizers.whitespace(d.value);
        },
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        dupDetector: function (remoteMatch, localMatch) {
            return remoteMatch.value.toString().toLowerCase() === localMatch.value.toString().toLowerCase();
        },
        prefetch: {
            url: '/handlers/AutoComplete.ashx?provider=prefetch',
            cacheKey: 'querysuggestions',
            filter: function (data) {
                prefetchVals = data;
                return $.map(data, function (val) {
                    return {
                        value: val
                    };
                });
            }
        },
        remote: {
            url: handlerURL,
            filter: function (data) {
                if (data != null) {
                    if (provider === 'google' || provider === 'bing') {
                        var parseData = $.parseJSON(data);
                        if (parseData != null) {
                            return $.map(parseData[1], function (val) {
                                return {
                                    value: val
                                };
                            });
                        }
                    }
                    else {
                        return $.map(data, function (val) {
                            return {
                                value: parseQueryVal(val)
                            };
                        });
                    }
                }
            }
        }
    });

    $('.typeaheadSearch').typeahead({
        highlight: showHighlights,
        hint: showHints,
        minLength: minLen,
    },
    {
        limit: maxResults,
        source: querysuggestions.ttAdapter(),
    }).on('typeahead:autocompleted', onSelected);

    querysuggestions.initialize();
}

function onSelected($e, datum) {
    $('.typeahead').typeahead('close');
}

function ChangeProvider(val) {
    provider = $('#changeProvider').val();
    $('.typeahead').typeahead('destroy');
    initSearchTypeahead();
}

function Search() {
    window.location = searchTemplate + encodeURI($('.tt-input').val());
}